package com.kdanmobile.pdfreaderviewapp

import android.content.Intent
import android.os.Bundle
import android.view.View
import com.kdanmobile.base.KdanBaseActivity
import kotlinx.android.synthetic.main.activity_main.*
import java.io.File
import java.io.FileOutputStream
import java.io.InputStream
import java.io.OutputStream

class MainActivity : KdanBaseActivity() {

    private val pdfFileName = "2019_Quick Start Guide_PDF Reader Android_JP.pdf"
    private val epubFileName = "evil.epub"

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        btn_mainActivity_openPdf.isEnabled = false
        btn_mainActivity_openEpub.isEnabled = false
        pb_mainActivity_loading.visibility = View.VISIBLE
        btn_mainActivity_openPdf.setOnClickListener { open(pdfFileName) }
        btn_mainActivity_openEpub.setOnClickListener { open(epubFileName) }
        Thread(Runnable {
            copyFileFromAssetIfNotExist(pdfFileName)
            copyFileFromAssetIfNotExist(epubFileName)
            runOnUiThread {
                btn_mainActivity_openPdf.isEnabled = true
                btn_mainActivity_openEpub.isEnabled = true
                pb_mainActivity_loading.visibility = View.GONE
            }
        }).start()
    }

    private fun open(fileName: String) {
        val file = File(filesDir, fileName)
        val intent = Intent(this, MyReaderActivity::class.java)
        intent.putExtra(MyReaderActivity.KEY_FILE_ABSOLUTE, file.absolutePath)
        intent.putExtra("copyFile", false)
        startActivity(intent)
    }

    private fun copyFileFromAssetIfNotExist(fileName: String) {
        val inputStream = assets.open(fileName)
        val dstFile = File(filesDir, fileName)
        if (!dstFile.exists()) {
            copyFile(inputStream, FileOutputStream(dstFile))
        }
    }

    private fun copyFile(inputStream: InputStream, outputStream: OutputStream) {
        val buffer = ByteArray(1024)
        var read: Int
        while (true) {
            read = inputStream.read(buffer)
            if (read == -1) break
            outputStream.write(buffer, 0, read)
        }
    }
}
