package com.kdanmobile.pdfreaderviewapp

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.os.Environment
import com.kdanmobile.reader.ReaderActivity
import com.kdanmobile.reader.setting.ReaderSettingDialogFragment
import com.kdanmobile.reader.thumb.PdfThumbDialogFragment
import java.io.File

class MyReaderActivity : ReaderActivity() {

    private val currentPagePrefs = "readerCurrentPagePrefs"
    private val currentPageKey = "readerCurrentPage"

    override fun saveCurrentPageIndex(filename: String, currentPage: Int) {
        val prefs = getSharedPreferences(currentPagePrefs, Context.MODE_PRIVATE)
        prefs.edit().putInt("$currentPageKey-$filename", currentPage).apply()
    }

    override fun loadCurrentPageIndex(filename: String, defaultValue: Int): Int {
        val prefs = getSharedPreferences(currentPagePrefs, Context.MODE_PRIVATE)
        return prefs.getInt("$currentPageKey-$filename", defaultValue)
    }

    override fun provideReaderSettingDialogFragment(): ReaderSettingDialogFragment {
        return ReaderSettingDialogFragment()
    }

    override fun providePdfThumbDialogFragment(): PdfThumbDialogFragment {
        return MyPdfThumbDialogFragment()
    }

    override fun getKdanPdfReaderFolder(): File {
        val external = Environment.getExternalStorageDirectory()
        val folder = File(external, "KdanPDFReader")
        if (!folder.exists() || !folder.isDirectory)
            folder.mkdirs()
        return folder
    }

    override fun onClickUserGuide() {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun onClickPrint() {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun onClickFileInfo() {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun onClickTextReflow() {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun onClickShare() {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun onClickKdanCloud() {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun isIBonPrintEnabled(): Boolean {
        return true
    }

    override fun onClickIBonPrint() {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun onBackPressedWhenNothingCanClose(): Boolean {
        return false
    }

    companion object {
        val KEY_FILE_ABSOLUTE = ReaderActivity.KEY_FILE_ABSOLUTE
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
    }
}
